//
// ConfigurationBase.h (W.Badgett)
//

#ifndef _ConfigurationBase_h
#define _ConfigurationBase_h

#include <iostream>
#include <boost/property_tree/ptree.hpp>
#include <boost/property_tree/xml_parser.hpp>

class ConfigurationBase
{
   public:

  ~ConfigurationBase() {}

  ConfigurationBase(std::string fileName):
    configFileName(fileName)
  {
    read_xml(configFileName,config);
  }

  boost::property_tree::ptree config;
  std::string configFileName;

  void print(std::ostream & os = std::cout) const
  {
    os << "  ConfigFileName         " << configFileName << std::endl;
  }
};

#endif
