//
//  LARASICDriver.h  (W.Badgett)
//
//  Class to configure the chain of Liquid Argon ASICs
//

#ifndef _LARASICDriver_h
#define _LARASICDriver_h

#include <stdio.h>
#include <fstream>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "LariatConfiguration.h"
#include "LARASICFragment.h"

class LARASICDriver
{
  public:

  bool ok;
  LariatConfiguration * config;
  LARASICConfiguration    * larasic;

 ~LARASICDriver();
  LARASICDriver(LariatConfiguration  * config_,
		LARASICConfiguration * larasic_);
  void print(std::ostream & os = std::cout);
  void writeConfiguration(std::ostream *dataFile, uint32_t eventCounter);

  int  channelToArray(int channel);
  bool incrementTestChannel();
  bool testOn();
  bool testOff();
  void downloadConfiguration();

 protected:
  bool sendCommand(char * line);
  void setTestChannel(int channel);
  void resetTestChannel(int channel);
  void drainPort();
  void shift();
  void serializeConfiguration();
  LARASICFragment fragment;
  int testChannel;
  int teensy;

};


#endif
