//
//  LariatConfiguration.h   (W.Badgett)
//

#ifndef _LariatConfiguration_h
#define _LariatConfiguration_h

#include <time.h>
#include "V1740Configuration.h"
#include "V1751Configuration.h"
#include "TDCConfiguration.h"
#include "WUTConfiguration.h"
#include "V1495Configuration.h"
#include "V2718Configuration.h"
#include "LARASICConfiguration.h"

class LariatConfiguration
{
  public:

  ~LariatConfiguration();

  LariatConfiguration(int runType_,
		      int events_);

  int runNumber;
  int runType;
  int events;
  struct timeval runStartTime;
  V1740Configuration   * v1740;
  V1751Configuration   * v1751;
  V1495Configuration   * v1495;
  V2718Configuration   * v2718;
  TDCConfiguration     * tdc;
  WUTConfiguration     * wut;
  LARASICConfiguration * larasic;

  std::stringstream xml;

  void dumpFile(std::ostream & os,
		const char * tag, 
		std::string fileName);
  void print(std::ostream & os = std::cout);
  void concat(std::ostream & os = std::cout);
};

#endif

