//
//  V1740Configuration.h   (W.Badgett)
//

#ifndef _V1740Configuration_h
#define _V1740Configuration_h

#include <cmath>
#include <iostream>
#include "CAENDecoder.h"
#include "CAENDigitizer.h"
#include "ConfigurationBase.h"
#include "CAENConfiguration.h"

class V1740Configuration: public CAENConfiguration
{
  public:

   ~V1740Configuration() {}
   V1740Configuration(std::string fileName = "/opt/lariat-online/config/V1740.config"): 
     CAENConfiguration(fileName),
     sampleReduction(0),
     externalRun(0),
     samplingRate(0)
    {
      sampleReduction      = config.get<int>("V1740.sampleReduction");
      externalRun          = config.get<int>("V1740.externalRun");
      samplingRate         = config.get<int>("V1740.samplingRate");
    }

    int  sampleReduction;
    int  externalRun;
    int  samplingRate;

    void print(std::ostream & os = std::cout) 
    {
      os << "V1740 CAENConfiguration follows" << std::endl;
      CAENConfiguration::print(os);
      os << "V1740 Configuration" << std::endl;
      os << "  SamplingRate          " << samplingRate << std::endl;
      os << "  SampleReduction       " << sampleReduction << 
	" factor of " << std::pow(2,sampleReduction) << std::endl;
      os << "  ExternalRun           " << externalRun << std::endl;
    }
};

#endif

