#ifndef lariat_artdaq_Overlays_TDCControllerFragment_hh
#define lariat_artdaq_Overlays_TDCControllerFragment_hh

#include "GenericFragment.hh"
#include "TDCFragment.h"


#include <iostream>


namespace lariat {
  class TDCControllerFragment;

  typedef GenericFragment<TDCFragment::TdcControllerHeader> TDCControllerFragmentBase;

}

class lariat::TDCControllerFragment : lariat::TDCControllerFragmentBase {

  public:

  using lariat::TDCControllerFragmentBase::getHeader;
  //  using lariat::TDCControllerFragmentBase::dataBegin;
  //  using lariat::TDCControllerFragmentBase::dataEnd;
  //  using lariat::TDCControllerFragmentBase::total_values;

  TDCControllerFragment(const uint8_t* const ptr ) : 
    lariat::TDCControllerFragmentBase( ptr ) {}


  void printHeader() const {
    std::cout << std::endl;
    std::cout << "Fragment size: " << getHeader()->fragmentSize << std::endl;
    std::cout << "Fragment type: " << getHeader()->fragmentType << std::endl;
    std::cout << "Spill word count: " << getHeader()->spillWordCount << std::endl;
    std::cout << "Spill word count buffer: " << getHeader()->spillWordCountBuffer << std::endl;
    std::cout << "Spill counter: " << getHeader()->spillCounter << std::endl;
    std::cout << "Controller number: " << static_cast<int>(getHeader()->controllerNumber ) << std::endl;
    
    std::cout << "Date: " << static_cast<int>(getHeader()->month ) << 
      "/" << static_cast<int>(getHeader()->day ) << 
      "/" << static_cast<int>(getHeader()->year ) << std::endl; 
  
    std::cout << "Time: " << static_cast<int>(getHeader()->hours ) << 
      ":" << static_cast<int>(getHeader()->minutes ) <<                    
      ":"  << static_cast<int>(getHeader()->seconds ) << std::endl; 
    
    std::cout << "Trigger counts: " << getHeader()->triggerCounts << std::endl;
    std::cout << "TDC status: " << getHeader()->tdcStatus << std::endl;
    std::cout << "Link status: " << getHeader()->linkStatus << std::endl;
    std::cout << "TDC active mask: 0x" << std::hex << getHeader()->tdcActiveMask << std::dec << std::endl;
    std::cout << "# TDCs: " << getHeader()->nTDCs << std::endl;
  
    std::cout << std::endl;
  }


};

#endif /* lariat_artdaq_Overlays_TDCControllerFragment_hh */
