#ifndef lariat_artdaq_Overlays_TDCSpillFragment_hh
#define lariat_artdaq_Overlays_TDCSpillFragment_hh

#include "GenericFragment.hh"
#include "TDCFragment.h"


#include <iostream>


namespace lariat {
  class TDCSpillFragment;

  typedef GenericFragment<TDCFragment::TdcSpillHeader> TDCSpillFragmentBase;

}

class lariat::TDCSpillFragment : lariat::TDCSpillFragmentBase {

  public:

  using lariat::TDCSpillFragmentBase::getHeader;

  //  using lariat::TDCSpillFragmentBase::dataEnd;
  //  using lariat::TDCSpillFragmentBase::total_values;

  TDCSpillFragment(const uint8_t* const ptr ) : 
    lariat::TDCSpillFragmentBase( ptr ) {}


  void printHeader() const {
    std::cout << std::endl;
    std::cout << "Fragment size: " << getHeader()->fragmentSize << std::endl;
    std::cout << "Fragment type: " << getHeader()->fragmentType << std::endl;
    std::cout << "Spill word count: " << getHeader()->spillWordCount << std::endl;
    std::cout << "Controller number: " << static_cast<int>(getHeader()->controllerNumber ) << std::endl;
    std::cout << "TDC number: " << static_cast<int>(getHeader()->tdcNumber ) << std::endl;
    std::cout << "Spill trigger counter: " << getHeader()->spillTriggerCounter << std::endl; 
    std::cout << "Spill status: " << getHeader()->spillStatus << std::endl; 
   
    std::cout << std::endl;
  }
  int TDCNumber(){

    return static_cast<int>(getHeader()->tdcNumber );

  }

};

#endif /* lariat_artdaq_Overlays_TDCSpillFragment_hh */
