#ifndef lariat_artdaq_Overlays_V1495HitFragment_hh
#define lariat_artdaq_Overlays_V1495HitFragment_hh

#include "GenericFragment.hh"
#include "V1495Fragment.h"


#include <iostream>


namespace lariat {
  class V1495HitFragment;

  typedef GenericFragment<V1495Fragment::V1495Header> V1495HitFragmentBase;

}

class lariat::V1495HitFragment : lariat::V1495HitFragmentBase {

  public:

  using lariat::V1495HitFragmentBase::getHeader;

  V1495HitFragment(const uint8_t* const ptr ) : 
    lariat::V1495HitFragmentBase( ptr ) {}


  void printHeader() const {
    std::cout << std::endl;
    std::cout << "Fragment size: " << getHeader()->fragmentSize << std::endl;
    std::cout << "Fragment type: " << getHeader()->fragmentType << std::endl;
    std::cout << "# Channels: " << getHeader()->nChan << std::endl;
    std::cout << "# Trig patterns: " << getHeader()->nTrigPat << std::endl;
    std::cout << "# Veto patterns: " << getHeader()->nVetoPat << std::endl;
    std::cout << "M: " << getHeader()->M << std::endl;
    std::cout << "tvMask: " << std::hex << getHeader()->tvMask << std::dec << std::endl;

    std::cout << std::endl;
  }


};

#endif /* lariat_artdaq_Overlays_V1495HitFragment_hh */
