#ifndef lariat_artdaq_Overlays_WUTHitFragment_hh
#define lariat_artdaq_Overlays_WUTHitFragment_hh

#include "GenericFragment.hh"
#include "WUTFragment.h"


#include <iostream>

// Implementation of "WUTHitFragment", an artdaq::Fragment overlay class
// to be used for event-by-event WUT fragments in the Lariat experiment


namespace lariat {
  class WUTHitFragment;

  typedef GenericFragment<WUTFragment::WutFrameHeader, WUTFragment::WutHit> WUTHitFragmentBase;

}

class lariat::WUTHitFragment : lariat::WUTHitFragmentBase {

  public:

  using lariat::WUTHitFragmentBase::getHeader;
  using lariat::WUTHitFragmentBase::dataBegin;
  using lariat::WUTHitFragmentBase::dataEnd;
  using lariat::WUTHitFragmentBase::total_values;

  WUTHitFragment(const uint8_t* const ptr ) : 
    lariat::WUTHitFragmentBase( ptr ) {}


  void printHeader() const {
    std::cout << std::endl;
    std::cout << "Fragment size: " << getHeader()->fragmentSize << std::endl;
    std::cout << "Fragment type: " << getHeader()->fragmentType << std::endl;
    std::cout << "Spill counter: " << getHeader()->spillCounter << std::endl;
    std::cout << "Poll count: " << getHeader()->pollCount << std::endl;
    std::cout << "Time header: " << getHeader()->timeHeader << std::endl;
    std::cout << "# Hits: " << getHeader()->nHits << std::endl;

    std::cout << std::endl;
  }


};

#endif /* lariat_artdaq_Overlays_WUTHitFragment_hh */
