#ifndef lariat_artdaq_ArtModules_GeneratorUtils_hh
#define lariat_artdaq_ArtModules_GeneratorUtils_hh

// JCF, 5/9/14

// GeneratorUtils is a utility module which provides the
// writeLariatFragment() function, designed to replace the
// now-obsolete *Writer classes used by fragment generators to convert
// lariat fragments into artdaq fragments. writeLariatFragment() does
// the following, given a reference to an artdaq::Fragment object and
// a pointer to a lariat fragment:

// -Determine the size and type of the lariat fragment, including sanity checks
// -Return the size and type by reference
// -Given the size, copy the lariat fragment into the artdaq::Fragment to be treated as payload

#include "LariatFragment.h"
#include "artdaq-core/Data/Fragment.hh"

#include <iostream>

namespace lariat {

  void writeLariatFragment(std::istream& lariatFragmentStream, 
			   artdaq::Fragment& artdaqFragment, 
			   std::size_t& lariatSize,
			   LariatFragment::LariatFragmentType& lariatType);
}

#endif // lariat_artdaq_ArtModules_GeneratorUtils_hh 
