#ifndef lariat_artdaq_Overlays_TDCEventFragment_hh
#define lariat_artdaq_Overlays_TDCEventFragment_hh

#include "GenericFragment.hh"
#include "TDCFragment.h"


#include <iostream>


namespace lariat {
  class TDCEventFragment;

  typedef GenericFragment<TDCFragment::TdcEventHeader, TDCFragment::TdcHit> TDCEventFragmentBase;

}

class lariat::TDCEventFragment : lariat::TDCEventFragmentBase {

  public:

  using lariat::TDCEventFragmentBase::getHeader;
  using lariat::TDCEventFragmentBase::dataBegin;
  using lariat::TDCEventFragmentBase::dataEnd;
  using lariat::TDCEventFragmentBase::total_values;

  TDCEventFragment(const uint8_t* const ptr ) : 
    lariat::TDCEventFragmentBase( ptr ) {}


  void printHeader() const {
    std::cout << std::endl;
    std::cout << "Fragment size: " << getHeader()->fragmentSize << std::endl;
    std::cout << "Fragment type: " << getHeader()->fragmentType << std::endl;
    std::cout << "Event word count: " << static_cast<int>(getHeader()->eventWordCount) << std::endl;
    std::cout << "Event status: " << static_cast<int>(getHeader()->eventStatus) << std::endl;
    std::cout << "Trigger counter: " << getHeader()->triggerCounter << std::endl;
    std::cout << "Trigger type: " << static_cast<int>(getHeader()->triggerType) << std::endl;
    std::cout << "Controller timestamp: " << getHeader()->controllerTimeStamp << std::endl;
    std::cout << "TDC timestamp: " << getHeader()->tdcTimeStamp << std::endl;
    std::cout << "# Hits: " << getHeader()->nHits << std::endl;
    std::cout << "Controller number: " << static_cast<int>(getHeader()->controllerNumber) << std::endl;
    std::cout << "TDC number: " << static_cast<int>(getHeader()->tdcNumber) << std::endl;

    std::cout << std::endl;
  }
  int TDCNumber(){

    return static_cast<int>(getHeader()->tdcNumber );

  }

  int TDCHits(){

    return static_cast<int>(getHeader()->nHits );

  }

  int TDCTimestamp(){

    return static_cast<int>(getHeader()->tdcTimeStamp );

  }

  int TDCControllerTimestamp(){

    return static_cast<int>(getHeader()->controllerTimeStamp );

  }

};

#endif /* lariat_artdaq_Overlays_TDCEventFragment_hh */
