#!/bin/bash

source `which setupDemoEnvironment.sh`

# create the configuration file for PMT
tempFile="/daqdata/log/pmt/pmtConfig.$$"

echo "BoardReaderMain `hostname` ${LARIATARTDAQ_BR_PORT[0]}" >> $tempFile
echo "BoardReaderMain `hostname` ${LARIATARTDAQ_BR_PORT[1]}" >> $tempFile
echo "EventBuilderMain `hostname` ${LARIATARTDAQ_EB_PORT[0]}" >> $tempFile
echo "EventBuilderMain `hostname` ${LARIATARTDAQ_EB_PORT[1]}" >> $tempFile

# create the logfile directories, if needed
logroot="/daqdata/log"
mkdir -p -m 0777 ${logroot}/pmt
mkdir -p -m 0777 ${logroot}/masterControl
mkdir -p -m 0777 ${logroot}/boardreader
mkdir -p -m 0777 ${logroot}/eventbuilder

# start PMT
pmt.rb -p ${LARIATARTDAQ_PMT_PORT} -d $tempFile --logpath ${logroot} --display ${DISPLAY}
rm $tempFile
