//
//  CAENDecoder class converts CAENDigitizer enumerated 
//  codes into human readable text   (W.Badgett)
//

#include "CAENDecoder.h"

#include <iostream>
#include <ctime>
#include "LariatException.h"

// Following function is not thread safe

const char * CAENDecoder::zeit(char delimiter)
{
  time_t t;
  struct tm * hora;
  static char heure[20];
  char format[20];

  sprintf(format,"%%Y.%%m.%%d-%%H%c%%M%c%%S", delimiter, delimiter);
  std::time(&t);
  hora = std::localtime(&t);
  std::strftime(heure,sizeof(heure),format,hora);
  return((char *)heure);
}


void CAENDecoder::commError(CAENComm_ErrorCode retcod,
			    const std::string label)
{
  if ( retcod != CAENComm_Success)
  {
    char buffer[256];
    CAENComm_DecodeError(retcod,buffer);
    std::cout << zeit() << " " << label 
	      << " error: " << buffer
	      << std::endl;
  }
}

void CAENDecoder::vmeError(CVErrorCodes      retcod,
			   const std::string label)
{
  if ( retcod != cvSuccess )
  {
    char buffer[256];
    CAENComm_DecodeError(retcod,buffer);
    std::cout << zeit() << " " << label 
	      << " error: " << buffer
	      << std::endl;
  }
}

void CAENDecoder::checkError(CAEN_DGTZ_ErrorCode err, 
			     const std::string label,
			     int boardId)
{
  if ( err != CAEN_DGTZ_Success )
  {
    LariatException e(err,label,boardId);
    std::cout << '\n' << zeit() << " " << e << std::endl;
    throw(e);
  }
}

