//
//  lariat-online/daq/src/LariatException.cc   (W.Badgett)
//

#include <iostream>
#include "LariatException.h"

LariatException::LariatException(CAEN_DGTZ_ErrorCode error_, 
				 std::string label_,
				 int boardId_):
    error(error_),
    label(label_),
    boardId(boardId_)
{
}

void LariatException::print() { std::cout << *this;}

std::ostream& operator<<(std::ostream& s, const LariatException& e)
{
  s << "ERROR: " << e.label << " " << CAENDecoder::CAENError(e.error);
  if ( e.boardId >= 0 ) { s << " BoardId " << e.boardId ;}
  s << std::endl;
  return(s);
}
