#include "V2718Configuration.h"

#include <string>
#include <iostream>


V2718Configuration::V2718Configuration(std::string fileName):
  ConfigurationBase(fileName)
{
    bridgeType           = config.get<int>("V2718.bridgeType");
    link                 = config.get<uint32_t>("V2718.link");
    enableReadout        = config.get<bool>("V2718.enableReadout"); 
    spillFlag            = config.get<bool>("V2718.spillFlag");
}

void V2718Configuration::print(std::ostream& os)  {
  using std::endl;
  os<<"=========== v2718 ==========="<<endl;
  ConfigurationBase::print(os);
  os<<"*Bridge Type : "<<bridgeType<<endl;
  os<<"*Link        : "<<link<<endl;
  os<<"*Readout     : "<< (enableReadout ?  "Enabled": "Disabled")<<endl; 
  os<<"*SpillFlag   : "<< (spillFlag     ?  "Enabled": "Disabled")<<endl; 
  
}
